#ifndef __SDLDEMO_FONT_BITFONT_H__
#define __SDLDEMO_FONT_BITFONT_H__

/***********************************************************************/

struct BitFontLetter
{
  int location;                 /* location of letter                  */
  int prekern;                  /* kerning before letter               */
  int cellwidth;                /* size of the character cell          */
  int totalwidth;               /* cellwidth+postkern                  */
};

struct BitFont 
{
  int BPR;                      /* bytes per row in font bitmap        */
  int Height;                   /* height of the font                  */
  int First;                    /* first letter in font                */
  int Count;                    /* number of letters in font           */
  int Bad;                      /* ASCII-number for bad characters     */
  struct BitFontLetter *Letters;/* letter structures, see above        */
  unsigned char *Data;          /* font bitmap                         */
};

#define POS_LEFT 1
#define POS_RIGHT 2
#define POS_TOP 4
#define POS_BOTTOM 8

/***********************************************************************/

int InitBitFont(struct BitFont *);
void KillBitFont(struct BitFont *);
int LoadBitFontFile(struct BitFont *,char *filename);
int LoadBitFontMemory(struct BitFont *,unsigned int *memory,int size);
int SaveBitFontFile(struct BitFont *,char *filename);
int SaveBitFontMemory(struct BitFont *,unsigned int **mem,int *size);

void Text(SDL_Surface *,struct BitFont *,int x,int y,
  unsigned int col,char *,int size);
void TextRect(SDL_Surface *,struct BitFont *,
  int x1,int y1,int x2,int y2,int align,
  unsigned int col,char *,int size);
int TextWidth(struct BitFont *,char *,int size);

/***********************************************************************/

#endif










