/*  BumpRace: a funny action game       Copyright (C) 1999 Karl Bartel                                           
                                                                                
    This program is free software; you can redistribute it and/or modify        
    it under the terms of the GNU General Public License as published by        
    the Free Software Foundation; either version 2 of the License, or           
    (at your option) any later version.                                         
                                                                                
    This program is distributed in the hope that it will be useful,       
    but WITHOUT ANY WARRANTY; without even the implied warranty of              
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               
    GNU General Public License for more details.                
                                                                               
    You should have received a copy of the GNU General Public License           
    along with this program; if not, write to the Free Software                 
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA   
                                                                                
    Karl Bartel                                                         
    Cecilienstr. 14                                                    
    12307 Berlin                                                  
    GERMANY
    karlb@gmx.net                                                      
*/                                                                            
#include <stdio.h>
#include <stdlib.h>
#include <SDL.h>
#include <SDL_timer.h>
#include <signal.h>
#include "bitfont.h"
#include "mixer/mixer.h"
#include "levels.h"
#include <math.h>

#define NUMBER_OF_LEVELS 18
#define BPP 16
#define RR 4                 //this a value of unprecision for the racer collision

       int final=1,fullscreen=0,pageflip=0,precision=10,sound=1,fps=0,particle=1,laser_switch=6000;   //settings

       float gravity=0,slowdown=0,turbo_possible=0,sticky_possible=0,extra_time=0,turbo=5;   //level and racer settings

       char modname[20]="lizard.mod";
       Mix_Chunk *explode_sound,*winlevel_sound,*teleport_sound;     
       Mix_Music *music;
       SDL_Event event;
       SDL_Rect dstrect[3],fillrect;
       SDL_Surface *screen, *timeout_pic, *explosion_pic, *title_pic, *select_pic;
       SDL_Surface *back, *racer[18], *fore[16], *pic_completed,*pic_crashed;
       SDL_Surface *racer_pic[4];
       int i,y,x,endgame=0,dontshow=0,crashed=0,completed=0,levelnum=0,quit=0;
       Uint8 *keys;
       float game_speed=100,f,teleported,average_speed,time_since_start;
       int frame_count=0,count_start=0; float frames_per_second,PARTICLES_OF_EXHAUST=150;
       int stop=0,stop2=0,infox,infoy,which_racer=0,levels_completed=0;
       float realx=5,realy=10,oldx=5,oldy=10,xspeed=0,yspeed=0,turn=0,turn_speed,accel_speed;
       int already=0,laser_state;  //limits the collisions to 1 per frame  
       Uint32 now;
       Sint32 lifetime=800000,last_lifetime;
       struct BitFont font;
       char text[40];
       char finished[28]={0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0}; // is level number X finished (1 or 0)

//////////////////////////////////////////// Begin Lion's Particle Code //////////////////
//#define PARTICLES_OF_EXHAUST 150
#define PARTICLE_LIFETIME 13
typedef struct
{
  int Lifetime;     // Lifetime of the current Particle
  float X;          // X coordinate
  float Y;          // Y coordinate
  float dX;         // delta X for each Particle frame
  float dY;         // delta Y for each Particle frame
  int R, G, B;      // Red, Green, and Blue for Particle
} Particle;

Particle particles[ 400 ];

int NullParticle;   // The NullParticle is the # of the last legal particle.
                    // Cannot reach PARTICLES_OF_EXHAUST!

#define PARTICLE_COLORS 5
int ParticleColorsR[] = { 255, 255, 200, 200, 80 };
int ParticleColorsG[] = { 255, 190, 90, 20,  0};
int ParticleColorsB[] = { 0, 0 ,   0,   50,   255 };
//////////////////////////////////////////// End Lion's Particle Code //////////////////


void ComplainAndExit(void)
{
        fprintf(stderr, "Problem: %s\n", SDL_GetError());
        exit(1);
}

void fast_putpixel2(SDL_Surface *dst, Uint16 x, Uint16 y, Uint32 pixel)         
{                                                                               
        *((Uint16 *)dst->pixels + y * dst->pitch/2 + x) = pixel;                
}                                                                               

Uint32 GetPixel(SDL_Surface *Surface, int X, int Y)
{
  unsigned char *bits;
  Uint32 Bpp;
  
  Bpp=2;
  
  bits = ((Uint8 *)Surface->pixels)+Y*Surface->pitch+X*Bpp;
  return *((Uint32 *)(bits));
}

void free_memory()
{
  if (sound)
  {
    Mix_FreeMusic(music);
    Mix_FreeChunk(explode_sound);
    Mix_FreeChunk(winlevel_sound);
    Mix_FreeChunk(teleport_sound);
    Mix_CloseAudio();
  }
  KillBitFont(&font);
}

void lock()
{
        if ( SDL_MUSTLOCK(screen) ) {
                if ( SDL_LockSurface(screen) < 0 )
		return;        }                                                                       
}

void unlock()
{
        if ( SDL_MUSTLOCK(screen) ) {                                           
	                SDL_UnlockSurface(screen); }                                                                       
}

void setpix( Sint32 X, Sint32 Y, Uint8 red, Uint8 green, Uint8 blue)
{                                                                               
  Uint32   pixel;
                            
  pixel = SDL_MapRGB(screen->format, red , green , blue);                                          
  fast_putpixel2 (screen, X, Y, pixel);      
}                                                                               



void fadeout1()
{
  int i;
  for (i=0;i<1000000;i++)
  {
    setpix(abrand(0,799),abrand(0,599),0,0,0);
    if (div(i,30000).rem==0) 
      {SDL_UpdateRect(screen,0,0,0,0);}
  }
}

void fadeout2()
{
  int x,y;
  
  for (x=0;x<800;x++)
  {
    lock();
    for (y=0;y<300;y++)
    {
      setpix(x,y*2,0,0,0);
    }
    unlock();
    {SDL_UpdateRect(screen,x,0,1,600);}
  }
  for (x=400;x>0;x--)
  {
    lock();
    for (y=299;y>0;y--)
    {
      setpix(x*2,y*2+1,0,0,0);
      setpix(x*2-1,y*2+1,0,0,0);
    }
    unlock();
    {SDL_UpdateRect(screen,x*2,0,2,600);}
  }
}

SDL_Surface *LoadImage(char *datafile, int transparent)   // reads one GIF into the memory
{
        SDL_Surface *image, *surface;
        extern SDL_Surface *ReadGIF(char *file);        /* From readGIF.c */

        image = ReadGIF(datafile);
        if ( image == NULL ) {
                return(NULL);
        }
        if ( transparent ) {
                /* Assuming 8-bit BMP image */
                SDL_SetColorKey(image,(SDL_SRCCOLORKEY|SDL_RLEACCEL),
                                   *(Uint8 *)image->pixels);
        }
        surface = SDL_DisplayFormat(image);
        SDL_FreeSurface(image);
        if ( surface == NULL ) {
                ComplainAndExit();
        }
        return(surface);
}

void blit(int Xpos,int Ypos,SDL_Surface *image)  //blits one GIF or BMP from the memory to the screen
{
  dstrect[0].x = Xpos;
  dstrect[0].y = Ypos;
  dstrect[0].w = image->w;
  dstrect[0].h = image->h;
  if ( SDL_BlitSurface(image, NULL, screen, &dstrect[0]) < 0 ) 
  {
    SDL_FreeSurface(image);
    ComplainAndExit();
  }
}

void blit_part(int Xpos,int Ypos,SDL_Surface *image, SDL_Rect srcrect)  //blits a part of one GIF or BMP from the memory to the screen
{
  dstrect[0].x = srcrect.x;
  dstrect[0].y = srcrect.y;
  dstrect[0].w = srcrect.w;
  dstrect[0].h = srcrect.h;
  if ( SDL_BlitSurface(image, &srcrect , screen, &dstrect[0]) < 0 ) 
  {
    SDL_FreeSurface(image);
    ComplainAndExit();
  }
}

void blit_back_point( int Xpos, int Ypos ) // blits 1 pixel from the back to the screen
{
  SDL_Rect srcrect;
  int tilenum;

  dstrect[ 0 ].x = Xpos;
  dstrect[ 0 ].y = Ypos;
  dstrect[ 0 ].w = 1;
  dstrect[ 0 ].h = 1;
  tilenum=map[levelnum][div(Ypos,40).quot][div(Xpos,40).quot];
//background
  if ((tilenum==0)||((tilenum==7)&&(!laser_state)))
  {
    if( SDL_BlitSurface( back, &dstrect[ 0 ], screen, &dstrect[ 0 ] ) < 0 )
    {
      SDL_FreeSurface( back );
      ComplainAndExit();
    }
  }else
//transparent surface 
  if ((tilenum>3)&&(tilenum<10))
  {
    srcrect.x = div(Xpos,40).rem;
    srcrect.y = div(Ypos,40).rem;
    srcrect.w = 1;
    srcrect.h = 1;
    if (GetPixel(fore[tilenum-1],srcrect.x,srcrect.y)==-1)
    {
      if( SDL_BlitSurface( back, &dstrect[ 0 ], screen, &dstrect[ 0 ] ) < 0 )
      {       
        SDL_FreeSurface( back );
        ComplainAndExit();
      }
    }else
    {
      if( SDL_BlitSurface( fore[tilenum-1], &srcrect, screen, &dstrect[ 0 ] ) < 0 )
        ComplainAndExit();
    }
  }else
//solid surface
  {
    srcrect.x = div(Xpos,40).rem;
    srcrect.y = div(Ypos,40).rem;
    srcrect.w = 1;
    srcrect.h = 1;
    if( SDL_BlitSurface( fore[map[levelnum][div(Ypos,40).quot][div(Xpos,40).quot]-1], &srcrect, screen, &dstrect[ 0 ] ) < 0 )
      ComplainAndExit();
  }
}

void init_SDL()  // sets the video mode
{
  if ( SDL_Init(SDL_INIT_VIDEO) < 0 ) {ComplainAndExit();}
  atexit(SDL_Quit);
  // Set the video mode (800x600 at BPP-bit depth)  
  if (fullscreen)  
    { 
      if (pageflip) {screen = SDL_SetVideoMode(800, 600, BPP, SDL_HWSURFACE|SDL_INIT_TIMER|SDL_FULLSCREEN|SDL_DOUBLEBUF|SDL_INIT_AUDIO);} 
      else {screen = SDL_SetVideoMode(800, 600, BPP, SDL_HWSURFACE|SDL_INIT_TIMER|SDL_FULLSCREEN|SDL_INIT_AUDIO);}
    }
  else { screen = SDL_SetVideoMode(800, 600, BPP, SDL_HWSURFACE|SDL_INIT_TIMER|SDL_INIT_AUDIO); }
  if ( screen == NULL ) {ComplainAndExit();}
  if ( SDL_Init(SDL_INIT_AUDIO) < 0 ) 
    {fprintf(stderr, "Couldn't initialize SDL: %s\n",SDL_GetError());exit(2);} 
}

void corner_collision(  Uint8 xblock, Uint8 yblock)
{
  float hyp,alpha,xold,yold;
  xold=xspeed;
  yold=yspeed;
  hyp=hypot(realx+15-xblock*40,realy+15-yblock*40);
  if (hyp<15-RR)
  {
    alpha=atan(-(realx+15-xblock*40)/(realy+15-yblock*40));
    xspeed=2*(xold*cos(alpha)+yold*sin(alpha))*cos(alpha)-xold;
    yspeed=2*(xold*cos(alpha)+yold*sin(alpha))*sin(alpha)-yold;
    already=1;
  }
}

void kollision()  //calcualtes all collisions
{
  Uint8 x,y,x2,y2,xbig,ybig,sticky;
  SDL_Rect reblit_back;
  if (( keys[SDLK_LCTRL] == SDL_PRESSED )&&(sticky_possible)) sticky=1; else sticky=0;
  if (already) {already=0;} else
  for (y=0;y<=14;y++) {
    for (x=0;x<=19;x++) {
//wall
      if (((map[levelnum][y][x]==1)||(map[levelnum][y][x]>10))&&((realx+30>x*40)&&(realx<x*40+38)&&(realy+30>y*40)&&(realy<y*40+38))&&(!stop))
      { 
      // edges
	if ((realy+15<y*40)&&(realy+30-RR>y*40)&&(!already)&&
	    (realx+15<(x+1)*40)&&(realx+15>x*40)&&(map[levelnum][y-1][x]!=1))
	    if (sticky) {yspeed=0;xspeed=0;} else if (yspeed>0) {yspeed=-yspeed;already=1;}
	if ((realx+15>(x+1)*40)&&(realx+RR<(x+1)*40)&&(!already)&&
	    (realy+15<(y+1)*40)&&(realy+15>y*40)&&(map[levelnum][y][x+1]!=1))	    
	    if (sticky) {yspeed=0;xspeed=0;} else if (xspeed<0) {xspeed=-xspeed;already=1;}
	if ((realy+15>(y+1)*40)&&(realy+RR<(y+1)*40)&&(!already)&&
	    (realx+15<(x+1)*40)&&(realx+15>x*40)&&(map[levelnum][y+1][x]!=1))
	    if (sticky) {yspeed=0;xspeed=0;} else if (yspeed<0) {yspeed=-yspeed;already=1;}
	if ((realx+15<x*40)&&(realx+30-RR>x*40)&&(!already)&&
	    (realy+15<(y+1)*40)&&(realy+15>y*40)&&(map[levelnum][y][x-1]!=1))	    
	    if (sticky) {yspeed=0;xspeed=0;} else if (xspeed>0) {xspeed=-xspeed;already=1;}
      // corners
        if ((realx+15>(x+1)*40)&&(realy+15<y*40)&&(!already)&&(map[levelnum][y][x+1]!=1)&&(map[levelnum][y-1][x]!=1))
	  {corner_collision(x+1,y);}
        if ((realx+15<x*40)&&(realy+15<y*40)&&(!already)&&(map[levelnum][y][x-1]!=1)&&(map[levelnum][y-1][x]!=1))
	  {corner_collision(x,y);}
        if ((realx+15>(x+1)*40)&&(realy+15>(y+1)*40)&&(!already)&&(map[levelnum][y][x+1]!=1)&&(map[levelnum][y+1][x]!=1))
	  {corner_collision(x+1,y+1);}
        if ((realx+15<x*40)&&(realy+15>(y+1)*40)&&(!already)&&(map[levelnum][y][x-1]!=1)&&(map[levelnum][y+1][x]!=1))
	  {corner_collision(x,y+1);}
      }
      if (stop) {stop--;}
      if (stop2) {stop2--;}
//lightning
      if ((map[levelnum][y][x]==2)&&((realx+24>x*40)&&(realx<x*40+32)&&(realy+24>y*40)&&(realy<y*40+32)))
      { 
	crashed=1;
      }
//stopper
      if ((map[levelnum][y][x]==3)&&((realx+24>x*40)&&(realx<x*40+32)&&(realy+24>y*40)&&(realy<y*40+32))&&(!stop2))
      { 
        xspeed=0;
	yspeed=0;
	stop2=100000;
      }
//finish
      if ((map[levelnum][y][x]==4)&&((realx+14>x*40)&&(realx<x*40+22)&&(realy+14>y*40)&&(realy<y*40+22))&&(!stop2))
      { 
        completed=1;
        endgame=1;
      }
//teleporter
      if ((map[levelnum][y][x]==5)&&((realx+10>x*40)&&(realx<x*40+18)&&(realy+10>y*40)&&(realy<y*40+18)))
      { 
        for (y2=0;y2<=14;y2++) {
          for (x2=0;x2<=19;x2++) {
            if (((x2!=x)||(y2!=y))&&(map[levelnum][y2][x2]==5)&&(teleported==0))
	    {realx=x2*40+2;realy=y2*40+2;teleported=30000000;	
            if (sound) {Mix_PlayChannel(1,teleport_sound,0);}}    
	  }
        }
      }
      if (teleported>0) {teleported-=game_speed;}
      if (teleported<0) {teleported=0;}
//time bonus
      if ((map[levelnum][y][x]==6)&&((realx+10>x*40)&&(realx<x*40+18)&&(realy+10>y*40)&&(realy<y*40+18)))
      { 
        map[levelnum][y][x]=0;lifetime+=160000;
	reblit_back.x=x*40;
        reblit_back.y=y*40;
        reblit_back.w=40;
        reblit_back.h=40; 
        blit_part(0,0,back,reblit_back);
        if (!fullscreen) {SDL_UpdateRects(screen,1,&reblit_back);}    
      }
//laser
      if ((map[levelnum][y][x]==7)&&((realx+24>x*40)&&(realx<x*40+32)&&(realy+24>y*40)&&(realy<y*40+32)))
      { 
	if (laser_state) crashed=1;
      }
    }
  } 
}

void thrust()
{
//////////////////////////////////////////// Begin Lion's Particle Code//////////////////
      float deltaspeedx, deltaspeedy;
      deltaspeedy = -cos(turn*0.01745)*(game_speed/precision);      // 0.01745=(2*PI)/360 thats RAD to DEG
      deltaspeedx = sin(turn*0.01745)*(game_speed/precision);
      yspeed+=deltaspeedy;
      xspeed+=deltaspeedx;
      // Karl's code here:
      //      yspeed-=cos(turn*0.01745)*(game_speed/precision);      // 0.01745=(2*PI)/360 thats RAD to DEG
      //      xspeed+=sin(turn*0.01745)*(game_speed/precision);

      if(( NullParticle < PARTICLES_OF_EXHAUST )&&(particle))
	{
	  int ColorIndex;
	  int Percent; // Damn. C is really really finicky about declarations! Urusai!
	  float scalefactor;

	  Particle* ThisParticle = &particles[ NullParticle ];
	  ThisParticle->Lifetime = PARTICLE_LIFETIME + abrand( -5, 5 );
	  ThisParticle->X = realx + 15;
	  ThisParticle->Y = realy + 15;
	  ThisParticle->dX = -deltaspeedx;
	  ThisParticle->dY = -deltaspeedy;
	  
	  ColorIndex = abrand( 0, PARTICLE_COLORS-1 );
	  ThisParticle->R = ParticleColorsR[ ColorIndex ];
	  ThisParticle->G = ParticleColorsG[ ColorIndex ];
	  ThisParticle->B = ParticleColorsB[ ColorIndex ];
	  // Introduce Orthogonal (y, -x) Component
	  switch( which_racer )
	    {
	    case 0: // SlowPoke
	      Percent = abrand( -50, 50 );
	      break;
	    case 1: // Normal
	      Percent = abrand( -25, 25 );
	      break;
	    case 2: // Speedy
	      Percent = abrand( -5, 5 );
	      break;
	    case 3: // Spinny
	      Percent = abrand( -60, 60 );
	      break;
	    default: // OOPS!
	      Percent = 0;
	    }
//	  	  ThisParticle->dX +=  (-deltaspeedy) * ((float) Percent) / ((float) 100);
//	  	  ThisParticle->dY += -(-deltaspeedx) * ((float) Percent) / ((float) 100);
	  	  ThisParticle->dX += ( (-deltaspeedy) * (float) Percent / 100 );
	  	  ThisParticle->dY += (-(-deltaspeedx) * (float) Percent / 100 );

	  // scale particle speed
	  // (because I'm having such difficulty finding a good scaling value...)
	  ThisParticle->dX /= 5000; //modified
	  ThisParticle->dY /= 5000; //modified

	  NullParticle++;
	}
//////////////////////////////////////////// End Lion's Particle Code ///////////////////
}

void readkeys() //reads keys and sets new coordinates
{
  float alpha,hyp;
  for(i=0;i<precision;i++)     // multiple times for a more precise collision
  {
    turn_speed=0.05*(game_speed/precision);
    accel_speed=400000/(game_speed/precision);

    SDL_PollEvent(&event);
    keys = SDL_GetKeyState(NULL);
    if ( keys[SDLK_UP] == SDL_PRESSED ) {
      thrust();
    }
    if ( keys[SDLK_RIGHT] == SDL_PRESSED ) {
      turn+=turn_speed;
    }
    if ( keys[SDLK_LEFT] == SDL_PRESSED ) {
      turn-=turn_speed;
    }
    if (( keys[SDLK_LCTRL] == SDL_PRESSED )&&(turbo_possible)) {
      yspeed-=cos(turn*0.01745)*turbo*(game_speed/precision);       
      xspeed+=sin(turn*0.01745)*turbo*(game_speed/precision);
    }
    realx=realx+xspeed/accel_speed;
    realy=realy+yspeed/accel_speed;
    if (realx<0) {realx=0;xspeed=-xspeed;}
    if (realx>768) {realx=768;xspeed=-xspeed;}
    if (realy<0) {realy=0;yspeed=-yspeed;}
    if (realy>568) {realy=568;yspeed=-yspeed;}
    kollision();
  }
//gravity
  yspeed+=(gravity)*game_speed;
//slowdown
  if (slowdown>0)
  {
    if (xspeed!=0) {alpha=atan(yspeed/xspeed);} else alpha=1;
    hyp=hypot(xspeed,yspeed);
    if ((xspeed<0))
    {  
      if (!gravity) {yspeed+=sin(alpha)*hyp*slowdown*game_speed;}
      {xspeed+=cos(alpha)*hyp*slowdown*game_speed;}
    }else
    {  
      if (!gravity) {yspeed-=sin(alpha)*hyp*slowdown*game_speed;}
      {xspeed-=cos(alpha)*hyp*slowdown*game_speed;}
    }
  }
}


void pic_kollision() //reblits overdrawn walls
{
  Uint8 x,y,xbig,ybig;  
  for (y=0;y<=14;y++) {
    for (x=0;x<=19;x++) {
      if ((map[levelnum][y][x]>0)&&((dstrect[1].x+34>x*40)&&(dstrect[1].x<x*40+42)&&(dstrect[1].y+34>y*40)&&(dstrect[1].y<y*40+42)))
        { 
	  if ((map[levelnum][y][x]!=7)||(laser_state)) blit(x*40,y*40,fore[map[levelnum][y][x]-1]); 
	}
    }
  } 
}

void DontReadKeys()
{
  SDL_EventState(SDL_KEYUP, SDL_IGNORE);                                  
  SDL_EventState(SDL_KEYDOWN, SDL_IGNORE);                                  
}

void draw_laser()
{
  SDL_Rect src_rect;
 
  Uint8 x,y,xbig,ybig;  
  for (y=0;y<=14;y++) {
    for (x=0;x<=19;x++) {
      if (map[levelnum][y][x]==7){ 
        src_rect.x=x*40;
        src_rect.y=y*40;
        src_rect.w=40;
        src_rect.h=40;
        blit_part(x*40,y*40,back,src_rect);
	if (laser_state) blit(x*40,y*40,fore[map[levelnum][y][x]-1]);
	SDL_UpdateRect(screen,x*40,y*40,40,40); 
      }
    }
  } 
}

void checks() //checks variables and blits messages to the screen
{
  if ( completed )
  {
    if (sound) {Mix_PlayChannel(1,winlevel_sound,0);}    
    DontReadKeys();
    SDL_SetAlpha(pic_completed,(SDL_SRCALPHA),210);
    now=SDL_GetTicks();
    while(SDL_GetTicks()-now<3000)
    {
      blit(160,250,pic_completed);
      if (!fullscreen) {SDL_UpdateRects(screen,1,&dstrect[0]);}    
    }
    endgame=1;
  }
  if ( crashed )
  {
    DontReadKeys();
    if (sound) {Mix_PlayChannel(1,explode_sound,0);}    
    SDL_SetAlpha(pic_crashed,(SDL_SRCALPHA),150);
    SDL_SetAlpha(explosion_pic,(SDL_SRCALPHA),210);
    now=SDL_GetTicks();
    while(SDL_GetTicks()-now<3000)
    {
      blit(250,250,pic_crashed);
      if (!fullscreen) {SDL_UpdateRects(screen,1,&dstrect[0]);}    
      blit(realx-6,realy-6,explosion_pic);               
      if (!fullscreen) {SDL_UpdateRects(screen,1,&dstrect[0]);}    
    }
    endgame=1;
    fadeout2();
  }
  if (lifetime<0) 
  {
    DontReadKeys();
    SDL_SetAlpha(timeout_pic,(SDL_SRCALPHA),220);
    now=SDL_GetTicks();
    while(SDL_GetTicks()-now<3000)
    {
      blit(250,250,timeout_pic);
      if (!fullscreen) {SDL_UpdateRects(screen,1,&dstrect[0]);}    
    }
    endgame=1;
    fadeout2();
  }
  if ((laser_state==0)&&(div(SDL_GetTicks(),laser_switch)).rem<(int)(laser_switch/2))
  {
    laser_state=1;
    draw_laser();
  }else
  if ((laser_state==1)&&(div(SDL_GetTicks(),laser_switch)).rem>(int)(laser_switch/2))
  {
    laser_state=0;
    draw_laser();
  }
}

void blit_lifetime()
{
  float x,y,xcol;
  
  if ((int)(lifetime/10000)!=(int)(last_lifetime/10000))
  {
    blit(infox*40   ,infoy*40,fore[10]);
    blit(infox*40+40,infoy*40,fore[11]);
    blit(infox*40+80,infoy*40,fore[12]);
    last_lifetime=lifetime;
    lock();
    for (x=0;x<(lifetime/10000);x++) {
      if (x*3<255) xcol=x*3; else xcol=255;
      for (y=0;y<10;y++) {
        setpix(x+infox*40+13,y+infoy*40+14,255-xcol,xcol,y);    
      }
    }
    unlock();
    if (!fullscreen) {SDL_UpdateRect(screen,infox*40+5, infoy*40+12,100,10);}    
  }
}

void UndrawParticles()
{
  int i;
  for( i = 0; i < NullParticle; i++ )
  {
    Particle* ThisParticle = &particles[ i ];
      if( ThisParticle->X > 0 )
        if( ThisParticle->X < 800 )
          if( ThisParticle->Y > 0 )
            if( ThisParticle->Y < 600 )
            {
	      blit_back_point( ThisParticle->X, ThisParticle->Y );
	      SDL_UpdateRect( screen, ThisParticle->X, ThisParticle->Y, 1, 1 );
	    }
  }
}

void HandleParticles()
{
  int i;

  for( i = 0; i < NullParticle; i++ )
  {
    Particle* ThisParticle = &particles[ i ];

    ThisParticle->Lifetime-=game_speed/1000;
    if( ThisParticle->Lifetime <= 0 )
    {
      // Delete this particle
      if( i != NullParticle -1 )
      {
        // We aren't the end particle, so we have to preserve the end.
        Particle* OtherParticle = &particles[ NullParticle - 1 ];
        *ThisParticle = *OtherParticle; // Default: Memberwise Assignment
      }
      NullParticle--;
      i--; // Do this cell once more...
    }
    else
    {
      int MorphColor;

      // Move this particle
      ThisParticle->X += ThisParticle->dX*game_speed; //modified
      ThisParticle->Y += ThisParticle->dY*game_speed; //modified

      MorphColor = 0;
      switch( ThisParticle->Lifetime )
      {
        case 25:
        case 20: MorphColor = 1; break;
	case 8:
        case 2: MorphColor = -1; break;
      }
      ThisParticle->R += MorphColor;
      ThisParticle->G += MorphColor;
      ThisParticle->B += MorphColor;
      // Strangely enough, it looks better *WITHOUT* the logical constraints!
      //	    if (ThisParticle->R>255) ThisParticle->R=255;
      //	    if (ThisParticle->R<0) ThisParticle->R=0;
      //	    if (ThisParticle->G>255) ThisParticle->G=255;
      //	    if (ThisParticle->G<0) ThisParticle->G=0;
      //	    if (ThisParticle->B>255) ThisParticle->B=255;
      //	    if (ThisParticle->B<0) ThisParticle->B=0;
    }
  }
}

void DisplayParticles()
{
  int i;

  lock();
  for( i = 0; i < NullParticle; i++ ){
    Particle* ThisParticle = &particles[ i ];
    int X, Y;
    X = ThisParticle->X;
    Y = ThisParticle->Y;
    X %= 800;
    Y %= 600;
    ThisParticle->X = X;
    ThisParticle->Y = Y;
    if( ThisParticle->X > 0 ) 
      if( ThisParticle->X < 800 ) 
        if( ThisParticle->Y > 0 ) 
          if( ThisParticle->Y < 600 ){
            setpix( ThisParticle->X, ThisParticle->Y,
	    ThisParticle->R, ThisParticle->G, ThisParticle->B );
	    SDL_UpdateRect( screen, ThisParticle->X, ThisParticle->Y, 1, 1 );
	  }
  } 
  unlock();
}

void draw_particles()
{
  UndrawParticles();
  HandleParticles();
  DisplayParticles();
}

void move()  // puts the sprite on the screen
{
  Uint8 pic,i;

  frame_count++;
  frames_per_second=frame_count*1000/((SDL_GetTicks()-count_start)+1);
  game_speed=(SDL_GetTicks()-now)*7;
 // printf("x:%f  y:%f  delay:%d   fps%f\n",realx,realy,(SDL_GetTicks()-now),frames_per_second);
  now=SDL_GetTicks();
  blit_part(0,0,back,dstrect[1]);
  if (turn<0) {turn=turn+360;}
  if (turn>360) {turn=turn-360;}
  for (i=0;i<=17;i++)   //selects the correct picture
  {
    if (turn+10>i*20) {pic=i;} 
  }
  pic_kollision();
  blit(realx,realy,racer[pic]);
  dstrect[0].x=realx;
  dstrect[0].y=realy;
  dstrect[0].w=30;
  dstrect[0].h=30;
  if (!fullscreen) {SDL_UpdateRects(screen,3,dstrect);}    
  dstrect[1]=dstrect[0];
  
//print lifetime and fps to the screen
  blit_lifetime();
  if (fps)
  {
    sprintf(text,"fps: %f",frames_per_second);
    Text(screen, &font, infox*40+13, infoy*40+28, 0,text, 8);
  }

  draw_particles();

  if (pageflip) {SDL_Flip(screen);}
}

void blit_fore() //blits the leves foreground (used only one time per level)
{
  Uint8 x,y;
  for (y=0;y<=14;y++) {
    for (x=0;x<=19;x++) {
      if (map[levelnum][y][x]!=0) { blit(x*40,y*40,fore[map[levelnum][y][x]-1]); }
    }
  }
}

void LookForInfo() //looks for the info box in this level
{
  int i;
  
  infox=-1;
  infoy=-1;
  for (y=0;y<=14;y++) {
    for (x=0;x<=19;x++) {
      if ((map[levelnum][y][x]==11)&&(infoy==-1)) 
      { 
        infox=x;
        infoy=y;
      }
    }
  } 
}

void load_images()
{
  Uint8 i;  

  for (i=0;i<=15;i++)
  {
    sprintf(text,"fore%d.gif",i+1);
    if ((i>3)&&(i<10)) {fore[i]=LoadImage(text,1);}
    else {fore[i]=LoadImage(text,0);}
  }
  racer_pic[0]=LoadImage("racer_big.gif",0);
  racer_pic[1]=LoadImage("racerb_big.gif",0);
  racer_pic[2]=LoadImage("racere_big.gif",0);
  racer_pic[4]=LoadImage("racerd_big.gif",0);
  racer_pic[3]=LoadImage("racerf_big.gif",0);
  select_pic=LoadImage("select.gif",0);
  timeout_pic=LoadImage("timeout.gif",1);
  explosion_pic=LoadImage("explosion1.gif",1);
  pic_completed=LoadImage("completed.gif",1);  
  pic_crashed=LoadImage("crashed.gif",1);  
  back=LoadImage("back3s.gif",0);  
}

void InitSound()
{
  if ( Mix_OpenAudio(22050, AUDIO_S16, 2, 4096) < 0 ) 
    {fprintf(stderr,"Warning: Couldn't set 22025 Hz 16-bit audio\n- Reason: %s\n",SDL_GetError());}
  music = Mix_LoadMUS(modname);
  if ( music == NULL ) {
    fprintf(stderr, "Couldn't load %s: %s\n",modname, SDL_GetError());
    SDL_Quit();
    exit(2);
  }
  explode_sound=Mix_LoadWAV_RW(SDL_RWFromFile("explode.wav", "rb"), 1);
  winlevel_sound=Mix_LoadWAV_RW(SDL_RWFromFile("winlevel.wav", "rb"), 1);
  teleport_sound=Mix_LoadWAV_RW(SDL_RWFromFile("whoosh.wav", "rb"), 1);
}

void ReadCommandLine(char *argv[])
{
  int i;
  for ( i=1;argv[i];i++ ) 
  {
    if ((strcmp(argv[i],"--nosound")==0)||(strcmp(argv[i],"-s")==0)) {sound=0;} else
    if ((strcmp(argv[i],"--fullscreen")==0)||(strcmp(argv[i],"-f")==0)) {fullscreen=1;} else
    if ((strcmp(argv[i],"--pageflip")==0)||(strcmp(argv[i],"-p")==0)) {pageflip=1;fullscreen=1;} else
    if ((strcmp(argv[i],"--notfinal")==0)||(strcmp(argv[i],"-n")==0)) {final=0;} else
    if ((strcmp(argv[i],"--noparticles")==0)||(strcmp(argv[i],"-t")==0)) {particle=0;} else
    if (strcmp(argv[i],"--fps")==0) {fps=1;} else
    if ((strcmp(argv[i],"--precision")==0)&&(argv[i+1])) 
      {i++;precision=atoi(argv[i]);printf("Precision is set to %d\n",precision);} else
    printf("Unknown parameter: \"%s\" \n", argv[i]);
  }
}

int abrand(int a,int b)  //random number between a and b (inclusive)            
{                                                                               
  return(a+(rand() % (b-a+1)));                                                 
}                                                                               


void BlitMenu()  //blits menu for SelectRacer
{
  for (i=0;i<=4;i++)
  {
    if (i==which_racer)
      {SDL_SetAlpha(racer_pic[i],(SDL_SRCALPHA),0);}
    else {SDL_SetAlpha(racer_pic[i],(SDL_SRCALPHA),180);}
  }
  SDL_FillRect(screen,&fillrect,0);
  blit(50,160,racer_pic[0]);
  blit(300,160,racer_pic[1]);
  blit(550,160,racer_pic[2]);
  blit(50,370,racer_pic[3]);
  blit(300,370,racer_pic[4]);
  Text(screen, &font, 110, 350, 655, "Best steering", -1);
  Text(screen, &font, 340, 350, 655, "10% extra time", -1);
  Text(screen, &font, 560, 350, 655, "High velocity (ctrl key)", -1);
  Text(screen, &font,  60, 560, 655, "Sticks to walls (ctrl key)", -1);
}

void load_racer() //loads the racer data
{
  if (which_racer==0) {
    for (i=0;i<=17;i++)
    {
      sprintf(text,"racerc%d.gif",i+1);
      racer[i]=LoadImage(text,1);
    }
  }else
  if (which_racer==1) {      
    for (i=0;i<=17;i++)
    {
      sprintf(text,"racerd%d.gif",i+1);
      racer[i]=LoadImage(text,1);
    }
  }else
  if (which_racer==2) {      
    for (i=0;i<=17;i++)
    {
      sprintf(text,"racere%d.gif",i+1);
      racer[i]=LoadImage(text,1);
    }
  }else
  {
    for (i=0;i<=17;i++)
    {
      sprintf(text,"racerf%d.gif",i+1);
      racer[i]=LoadImage(text,1);
    }
  }  
  if (which_racer==0) {slowdown=0.00010;}
  if (which_racer==1) {extra_time=10;}
  if (which_racer==2) {turbo_possible=1;}
  if (which_racer==3) {sticky_possible=1;}
}

void SelectRacer()  //menu for racer selection
{  
  int i;
  
  fillrect.x=50;
  fillrect.y=160;
  fillrect.w=700;
  fillrect.h=410;
  SDL_PollEvent(&event);
  keys = SDL_GetKeyState(NULL);
  while (keys[SDLK_RETURN]!=SDL_PRESSED)  
  {    
    SDL_PollEvent(&event);
    keys = SDL_GetKeyState(NULL);
    while (!SDL_WaitEvent(&event))
    {
      SDL_PollEvent(&event);
      keys = SDL_GetKeyState(NULL);
    }
    if (( keys[SDLK_RIGHT] == SDL_PRESSED )&&(which_racer<4))
      {which_racer++;}
    if (( keys[SDLK_LEFT] == SDL_PRESSED  )&&(which_racer>0))
      {which_racer--;}
    if (( keys[SDLK_DOWN] == SDL_PRESSED  )&&(which_racer<2))
      {which_racer+=3;}
    if (( keys[SDLK_UP] == SDL_PRESSED  )&&(which_racer>2))
      {which_racer-=3;}
      if (which_racer>4) which_racer=4;
    BlitMenu();
    SDL_UpdateRects(screen,1,&fillrect);
  }
}

void nextlevel() //selects the next level at random
{
  int i;
  finished[levelnum]=1;
  lifetime+=(int)(150000*(1+extra_time/100));
  quit=1;
  for (i=0;i<NUMBER_OF_LEVELS;i++)
  {
    if (finished[i]==0) {quit=0;}
  }
  if (!quit)
  {
    while (finished[levelnum]==1)
    {
      levelnum=abrand(0,NUMBER_OF_LEVELS-1);
    }
    levels_completed++;
  }
  else printf("\n ** CONGRATULATIONS! You have completed all levels. ** \n\n");
  sprintf(text,"BumpRace: Level #%d",levelnum);
  SDL_WM_SetCaption(text,"BumpRace");
}

void clear_screen()
{
  fillrect.x=0;
  fillrect.y=0;
  fillrect.w=800;
  fillrect.h=600;
  SDL_FillRect(screen,&fillrect,0);
}

void help()  //prints the help & credits screeen
{
  int i;
 
  clear_screen();
  for (i=0;i<=5;i++)
  {
    blit(60,160+i*70,fore[i]);
  }
  blit(300,-30,racer_pic[4]);
  Text(screen, &font, 115, 175, 855, "Normal wall", -1);
  Text(screen, &font, 115, 245, 855, "Deadly wall", -1);
  Text(screen, &font, 115, 315, 855, "Stopper", -1);
  Text(screen, &font, 115, 385, 855, "Your goal is to arrive here", -1);  
  Text(screen, &font, 115, 455, 855, "Teleporter", -1);  
  Text(screen, &font, 115, 525, 855, "Time bonus", -1);  

  Text(screen, &font, 450, 165, 855, "Code:", -1);  
  Text(screen, &font, 450, 180, 855, "Karl Bartel (main code) <karlb@gmx.net>", -1);  
  Text(screen, &font, 450, 195, 855, "Lion Kimbro (particles) <SnowLion@sprynet.com>", -1);  
  Text(screen, &font, 450, 220, 855, "Graphics:", -1);  
  Text(screen, &font, 450, 235, 855, "Karl Bartel", -1);  

  Text(screen, &font, 450, 265, 855, "Backgrounds:", -1);  
  Text(screen, &font, 450, 280, 855, "Unknown (see readme)", -1);  
  Text(screen, &font, 450, 305, 855, "Music:", -1);  
  Text(screen, &font, 450, 320, 855, "The Lizard King <www.itv.se/~a1055/frames.html>", -1);  

  Text(screen, &font, 450, 365, 855, "Sound Effects:", -1);  
  Text(screen, &font, 450, 380, 855, "grabbed from ClanBomber", -1);  
  Text(screen, &font, 450, 405, 855, "Levels:", -1);  
  Text(screen, &font, 450, 420, 855, "Karl Bartel", -1);  
  Text(screen, &font, 450, 435, 855, "Stephan <emailme@enthralling.com>", -1);  

  Text(screen, &font, 450, 465, 855, "Libraries used:", -1);  
  Text(screen, &font, 450, 480, 855, "SDL by Sam Lantinga", -1);  
  Text(screen, &font, 450, 495, 855, "Fontlib by Dierk Ohlerich", -1);  
  Text(screen, &font, 450, 510, 855, "GIF loading by David Koblas", -1);  
  Text(screen, &font, 450, 525, 855, "modified MikMod (for SDL)", -1);

  Text(screen, &font, 140, 580, 855, "You can find the BumpRace web page at: http://members.linuxstart.com/~karlb/",-1);  
  SDL_UpdateRect(screen,0,0,0,0);
  SDL_WaitEvent(&event);
  SDL_WaitEvent(&event);
  clear_screen();
  BlitMenu();
  blit(100,30,select_pic);
  SDL_UpdateRect(screen,0,0,0,0);
}

main(int argc, char *argv[])
{
//intialisation
  ReadCommandLine(argv);
  init_SDL();
  srand( (unsigned) time(NULL) );    
  SDL_EventState(SDL_MOUSEMOTION, SDL_IGNORE);                                  
  fullscreen=0;  //activate update_rects
  levelnum=abrand(0,NUMBER_OF_LEVELS-1);  
  sprintf(text,"BumpRace: Level #%d",levelnum);
  SDL_WM_SetCaption(text,"BumpRace");
//show title screen
  title_pic=LoadImage("title.gif",0);
  blit(0,0,title_pic);
  LoadBitFontFile(&font,"font.scl");
  Text(screen, &font, 150, 400, 655, "BumpRace Version 1.00 Copyright (C) 1999 Karl Bartel", -1);
  Text(screen, &font, 150, 415, 655, "BumpRace comes with ABSOLUTELY NO WARRANTY; for details see COPYING.", -1);
  Text(screen, &font, 150, 430, 655, "This is free software, and you are welcome to redistribute it", -1);
  Text(screen, &font, 150, 445, 655, "under certain conditions; see COPYING for details.", -1);
  SDL_UpdateRect(screen,0,0,0,0);
//load data
  if (sound) {InitSound();}
  if ((!Mix_PlayingMusic())&&(sound)) {Mix_PlayMusic(music);}				
  load_images();
  if (final) SDL_Delay(1800);
//racer select
  if (final) 
  {
    clear_screen();
    BlitMenu();
    blit(100,30,select_pic);
    SDL_UpdateRect(screen,0,0,0,0);
    while (1)
    {
      SelectRacer();
      if (which_racer==4) {help();} 
        else {break;}
    }
  }
  load_racer();  
  lifetime+=(lifetime*extra_time)/100;
//start level  
  while (!quit)
  {
    NullParticle = 0;   // No Particles
    endgame=0; completed=0; realx=5; realy=5; xspeed=0.001; yspeed=0.0001; crashed=0;
    dstrect[1].x=0;dstrect[1].y=0;teleported=0;game_speed=1;count_start=SDL_GetTicks();
    frame_count=0;now=SDL_GetTicks();time_since_start=0;
    if (levelnum==12) {gravity=1;realy=560;} else {gravity=0;}
    if (levelnum==13) {realy=270;} 
    if (levelnum==14) {realx=370;realy=290;} 
    if (levelnum==15) {realx=750;realy=40;} 
    if (levelnum==16) {realx=370;realy=50;} 
    if (levelnum==17) {realx=370;realy=570;gravity=0.3;} 
    for (i=0;i<=1;i++)              
    {
      blit(0,0,back);                
      blit_fore();
      LookForInfo();
      SDL_UpdateRect(screen,0,0,0,0); 
      if (pageflip) {SDL_Flip(screen);}
    } 
    readkeys();
    SDL_EventState(SDL_KEYUP, SDL_ENABLE);                                  
    SDL_EventState(SDL_KEYDOWN, SDL_ENABLE);                                  
//game loop
    while (!endgame)
    {
      move();                                //puts sprite
      if ( keys[SDLK_ESCAPE] == SDL_PRESSED ) 
        {endgame=1;lifetime=0;}  
      readkeys();                            //sets new coordinates
      checks();
      lifetime-=game_speed;
      if ((!Mix_PlayingMusic())&&(sound)) {Mix_PlayMusic(music);}
      time_since_start+=game_speed;
      average_speed=time_since_start/frame_count;
//      printf("games: %f    average: %f \n",game_speed,average_speed);
      PARTICLES_OF_EXHAUST=500-game_speed;
      if (PARTICLES_OF_EXHAUST>400) PARTICLES_OF_EXHAUST=400;
      if (PARTICLES_OF_EXHAUST<0) PARTICLES_OF_EXHAUST=0;
    }
//end of game loop
    if (completed) 
    {  
      nextlevel();
    } else 
    {
      if (lifetime<0) {printf("\n\nTIMEOUT! You have completed %d levels.\n\n\n",levels_completed);quit=1;}
    }
    if (quit) break;
  }  
  free_memory();
  printf("Awaiting SDL_Quit()\n");
  SDL_Quit();
}